//----------------------------------------------------------------------------------
// aviutlvOC
// Deinterlace caps zĎtB^
//
//----------------------------------------------------------------------------------
#include <windows.h>

#include "filter.h"

// ֐
int line_diff(FILTER *, FILTER_PROC_INFO *);
int bob_rep(FILTER *, FILTER_PROC_INFO *);
int bob2tap(FILTER *, FILTER_PROC_INFO *);
int bob4tap(FILTER *, FILTER_PROC_INFO *);
int median(FILTER *, FILTER_PROC_INFO *);
int dirflt(FILTER *, FILTER_PROC_INFO *);
int timeflt(FILTER *, FILTER_PROC_INFO *);
int region(FILTER *, FILTER_PROC_INFO *);

// op
typedef struct _tagD {
  int field;
  int frame;
} D;
D *gp_diff = NULL;
int gp_diff_size = 0;

//---------------------------------------------------------------------
//tB^\̒`
//---------------------------------------------------------------------
#define TRACK_N 7 //gbNo[̐
TCHAR *track_name[] = {"method", "l_diff", "t_diff", "left", "top", "width", "height" }; //gbNo[̖O
int   track_default[] = { 0, 128, 64, 0, 0, 640, 480 }; //gbNo[̏l
int   track_s[] = { 0, 0, 0, 0, 0, 0, 0 }; //gbNo[̉l
int   track_e[] = { 5, 256, 256, 2048, 2048, 2048, 2048 }; //gbNo[̏l
enum  { T_M, T_LDIFF, T_TDIFF, T_LEFT, T_TOP, T_WIDTH, T_HEIGHT };

#define CHECK_N 6 //`FbN{bNX̐
TCHAR *check_name[] = { "pixel adaptive", "frame","frame+", "top", "\", "͈͎w" }; //`FbN{bNX̖O
int    check_default[] = { 0, 1, 1, 1, 0, 0 }; //`FbN{bNX̏l (l01)
enum { C_PA, C_FRAME, C_FRAMEP, C_TOP, C_DISP, C_REGION };

FILTER_DLL filter = {
  FILTER_FLAG_EX_INFORMATION, //| FILTER_FLAG_WINDOW_SIZE, //tB^̃tO
  0,0,                        //ݒEChẼTCY (FILTER_FLAG_WINDOW_SIZEĂ鎞ɗL)
  "deint_test", //tB^̖O
  TRACK_N,                    //gbNo[̐ (0Ȃ疼OlNULLł悢)
  track_name,                 //gbNo[̖OSւ̃|C^
  track_default,              //gbNo[̏lSւ̃|C^
  track_s,track_e,            //gbNo[̐l̉ (NULLȂS0`256)
  CHECK_N,                    //`FbN{bNX̐ (0Ȃ疼OlNULLł悢)
  check_name,                 //`FbN{bNX̖OSւ̃|C^
  check_default,              //`FbN{bNX̏lSւ̃|C^
  func_proc,                  //tB^֐ւ̃|C^ (NULLȂĂ΂܂)
  NULL,                       //JnɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
  func_exit,                  //IɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
  NULL,                       //ݒ肪ύXꂽƂɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
  NULL,                       //ݒEBhEɃEBhEbZ[WɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
  NULL,NULL,                  //VXeŎg܂̂ŎgpȂł
  NULL,                       //  gf[^̈ւ̃|C^ (FILTER_FLAG_EX_DATAĂ鎞ɗL)
  0,                       //  gf[^TCY (FILTER_FLAG_EX_DATAĂ鎞ɗL)
  "deint_test by N099, ver1.1",  //  tB^ւ̃|C^ (FILTER_FLAG_EX_INFORMATIONĂ鎞ɗL)
  NULL,                       //Z[uJn钼OɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
  NULL,                       //Z[uIOɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)

};

//---------------------------------------------------------------------
//     tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
  return &filter;
}

//---------------------------------------------------------------------
// IɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_exit( FILTER *fp )
{
  if(NULL != gp_diff){
    free(gp_diff);
    gp_diff = NULL;
    gp_diff_size = 0;
  }

  return TRUE;
}

//---------------------------------------------------------------------
// tB^֐
//---------------------------------------------------------------------
BOOL func_proc( FILTER *fp,FILTER_PROC_INFO *fpip )
{
  PIXEL_YC *ycp;

  if(!fp->exfunc->set_ycp_filtering_cache_size(fp, fpip->max_w, fpip->h, 2,0))
    return FALSE;
  
  if(fp->check[C_DISP] && 5 == fp->track[T_M]){
    line_diff(fp, fpip);
        
    ycp = fpip->ycp_temp;
    fpip->ycp_temp = fpip->ycp_edit;
    fpip->ycp_edit = ycp;
    return TRUE;
  }
  
  if(fp->track[T_M]){
    if(1 == fp->track[T_M])
      bob_rep(fp, fpip);
    else if(2 == fp->track[T_M])
      bob2tap(fp, fpip);
    else if(3 == fp->track[T_M])
      bob4tap(fp, fpip);
    else if(4 == fp->track[T_M])
      median(fp, fpip);
    else if(5 == fp->track[T_M])
      dirflt(fp, fpip);
        
    ycp = fpip->ycp_temp;
    fpip->ycp_temp = fpip->ycp_edit;
    fpip->ycp_edit = ycp;
  }

  if(fp->check[C_REGION] && fp->track[T_M]){
    region(fp, fpip);
  }
  
  if(fp->check[C_PA] && fp->track[T_M]){
    timeflt(fp, fpip);
        
    ycp = fpip->ycp_temp;
    fpip->ycp_temp = fpip->ycp_edit;
    fpip->ycp_edit = ycp;
  }
  
  return TRUE;
}

// אڃTvRs[
int bob_rep(FILTER *fp, FILTER_PROC_INFO *fpip)
{
  PIXEL_YC *src, *dst;
  int h = fpip->h;
  int i;
  int l = fpip->max_w;

  for(i=0; i<h; i++){
    src = fpip->ycp_edit + i*l;
    dst = fpip->ycp_temp + i*l;

    if(fp->check[C_TOP]){
      src -= (i&1)*l;
    }else{
      src += (1-(i&1))*l;
    }
    memcpy(dst, src, l * sizeof(PIXEL_YC));
  }

  return 0;
}

// ㉺2Tv̕
int bob2tap(FILTER *fp, FILTER_PROC_INFO *fpip)
{
  PIXEL_YC *src, *dst;
  int l0, l1;
  int h = fpip->h;
  int i,j;
  int l = fpip->max_w;
  PIXEL_YC yct, yct0, yct1;

  for(i=0; i<h; i++){
    src = fpip->ycp_edit + i*l;
    dst = fpip->ycp_temp + i*l;

    if(((i&1) && fp->check[C_TOP]) || ((0 == (i&1)) && 0 == fp->check[C_TOP])){
      l1 = i-1 < 0 ? 1  : -1;
      l0 = i+1 >= h ? -1 :  1;
      for(j=0; j<fpip->w; ++j){
        yct0 = *(src + l*l0);
        yct1 = *(src + l*l1);

        yct.y = (yct0.y + yct1.y)/2;
        yct.cb = (yct0.cb + yct1.cb)/2;
        yct.cr = (yct0.cr + yct1.cr)/2;
        
        *dst = yct;
        ++src;
        ++dst;
      }
    }else{
      memcpy(dst, src, l * sizeof(PIXEL_YC));
    }
  }

  return 0;
}

// ㉺4Tvɂ
int bob4tap(FILTER *fp, FILTER_PROC_INFO *fpip)
{
  PIXEL_YC *src, *dst;
  int l0, l1, l2, l3;
  int h = fpip->h;
  int i,j;
  int l = fpip->max_w;
  PIXEL_YC yct, yct0, yct1, yct2, yct3;

  for(i=0; i<h; i++){
    src = fpip->ycp_edit + i*l;
    dst = fpip->ycp_temp + i*l;

    if(((i&1) && fp->check[C_TOP]) || ((0 == (i&1)) && 0 == fp->check[C_TOP])){
      l1 = i-1 < 0 ? 1  : -1;
      l0 = i-3 < 0 ? l1 : -3;
      l2 = i+1 >= h ? -1 :  1;
      l3 = i+3 >= h ? l2 :  3;
      for(j=0; j<fpip->w; ++j){
        yct0 = *(src + l*l0);
        yct1 = *(src + l*l1);
        yct2 = *(src + l*l2);
        yct3 = *(src + l*l3);
        // -1, 9, 9, -1 tB^
        yct.y = (9*(yct1.y + yct2.y) - (yct0.y + yct3.y))/16;
        yct.cb = (9*(yct1.cb + yct2.cb) - (yct0.cb + yct3.cb))/16;
        yct.cr = (9*(yct1.cr + yct2.cr) - (yct0.cr + yct3.cr))/16;
        
        *dst = yct;
        ++src;
        ++dst;
      }
    }else{
      memcpy(dst, src, l * sizeof(PIXEL_YC));
    }
  }

  return 0;
}

// ㉺+Ƃ̈ʒu3pixelŒԒl߁A𗘗p
int median(FILTER *fp, FILTER_PROC_INFO *fpip)
{
  short *src, *dst;
  int l0, l1;
  int h = fpip->h;
  int i,j;
  int l = fpip->max_w * (sizeof(PIXEL_YC) / sizeof(short));
  int w = fpip->w * (sizeof(PIXEL_YC) / sizeof(short));
  short tmp, s0 ,s1, s2;

  for(i=0; i<h; i++){
    src = (short *)(fpip->ycp_edit) + i*l;
    dst = (short *)(fpip->ycp_temp) + i*l;

    if(((i&1) && fp->check[C_TOP]) || ((0 == (i&1)) && 0 == fp->check[C_TOP])){
      l0 = i-1 < 0 ? 1  : -1;
      l1 = i+1 >= h ? -1 :  1;
      for(j=0; j<w; ++j){
        s0 = *(src + l*l0);
        s1 = *src;
        s2 = *(src + l*l1);
       
        
        //sort
        if(s0 > s1){
          tmp = s1;
          s1 = s0;
          s0 = tmp;
        }
        if(s1 > s2){
          tmp = s2;
          s2 = s1;
          s1 = tmp;
        }
        if(s0 > s1){
          tmp = s1;
          s1 = s0;
          s0 = tmp;
        }
        
        *dst = s1;
        ++src;
        ++dst;
      }
    }else{
      memcpy(dst, src, fpip->max_w * sizeof(PIXEL_YC));
    }
  }

  return 0;
}


// Βl̘a
int sad_yc(PIXEL_YC *yc0, PIXEL_YC *yc1)
{
  int diff;
  diff = abs(yc0->y - yc1->y);
  diff += abs(yc0->cb - yc1->cb);
  diff += abs(yc0->cr - yc1->cr);

  return diff;
}

// 
PIXEL_YC avr_yc(PIXEL_YC *yc0, PIXEL_YC *yc1)
{
  PIXEL_YC ret;
  
  ret.y = (yc0->y + yc1->y)/2;
  ret.cb = (yc0->cb + yc1->cb)/2;
  ret.cr = (yc0->cr + yc1->cr)/2;

  return ret;
}

// ԃtB^i}Nj
//
// ʒu֌W
// x : -1, 0, 1
//         t
// y : -1, 0, 1
// (t : Ԃ̃^[Qbg)
// z : (x)
// a : d(𔽉fƂɗp)
//
#define DIRFLT(x, y, z, a) { \
  pyc0 = src - ln + (x);\
  pyc1 = src + ln + (y);\
  sad_sort[(z)] = ((a)*sad_yc(pyc0, pyc1)) >> 4;\
  ycp_tbl[(z)] = avr_yc(pyc0, pyc1);\
  idx[(z)] = (z);\
}\

// tB^si[j
PIXEL_YC do_dirflt_left(FILTER *fp, PIXEL_YC *src, int ln)
{
  int i;
  int sad_sort[3];
  int sad_tmp;
  int idx[3];
  int idx_tmp;
  PIXEL_YC ycp_tbl[3];
  PIXEL_YC  *pyc0, *pyc1;

  DIRFLT(0, 0, 0, 16)
  DIRFLT(1, 0, 1, 16)
  DIRFLT(0, 1, 2, 16)

  for(i=0; i<2; i++){
    if(sad_sort[i+1] > sad_sort[i]){
      sad_tmp = sad_sort[i];
      sad_sort[i] = sad_sort[i+1];
      sad_sort[i+1] = sad_tmp;
      idx_tmp = idx[i];
      idx[i] = idx[i+1];
      idx[i+1] = idx_tmp;
    }
  }

  return ycp_tbl[idx[2]];
}

// tB^siE[j
PIXEL_YC do_dirflt_right(FILTER *fp, PIXEL_YC *src, int ln)
{
  int i;
  int sad_sort[3];
  int sad_tmp;
  int idx[3];
  int idx_tmp;
  PIXEL_YC ycp_tbl[3];
  PIXEL_YC *pyc0, *pyc1;

  DIRFLT(0,  0, 0, 16)
  DIRFLT(-1, 0, 1, 16)
  DIRFLT(0, -1, 2, 16)

  for(i=0; i<2; i++){
    if(sad_sort[i+1] > sad_sort[i]){
      sad_tmp = sad_sort[i];
      sad_sort[i] = sad_sort[i+1];
      sad_sort[i+1] = sad_tmp;
      idx_tmp = idx[i];
      idx[i] = idx[i+1];
      idx[i+1] = idx_tmp;
    }
  }

  return ycp_tbl[idx[2]];
}

// tB^si[ȊOj
PIXEL_YC do_dirflt(FILTER *fp, PIXEL_YC *src, int ln)
{
  int i;
  int sad_sort[7];
  int sad_tmp;
  int idx[7];
  int idx_tmp;
  PIXEL_YC ycp_tbl[7];
  PIXEL_YC *pyc0, *pyc1;

  DIRFLT(0,  0, 0, 16)
  DIRFLT(-1, 0, 1, 16)
  DIRFLT(0, -1, 2, 16)
  DIRFLT(0,  1, 3, 16)
  DIRFLT(1,  0, 4, 16)
  DIRFLT(1, -1, 5, 16)
  DIRFLT(-1, 1, 6, 16)

  for(i=0; i<6; i++){
    if(sad_sort[i+1] > sad_sort[i]){
      sad_tmp = sad_sort[i];
      sad_sort[i] = sad_sort[i+1];
      sad_sort[i+1] = sad_tmp;
      idx_tmp = idx[i];
      idx[i] = idx[i+1];
      idx[i+1] = idx_tmp;
    }
  }

  return ycp_tbl[idx[6]];
}

//tB^i΂ߐ̕ԁj
int dirflt(FILTER *fp, FILTER_PROC_INFO *fpip)
{
  PIXEL_YC *src, *dst;
  int h = fpip->h - 1;
  int i,j;
  int ln = fpip->max_w;
  short th = fp->track[T_LDIFF] * 8;
  
  // ܂4tapbobĂ(e炷2tapłOKȋCr)
  bob4tap(fp, fpip);

  // ΂߂̐ۂƂ낾
  for(i=1; i<h; i++){
    src = fpip->ycp_edit + i*ln;
    dst = fpip->ycp_temp + i*ln;
    if(((i&1) && fp->check[C_TOP]) || ((0 == (i&1)) && 0 == fp->check[C_TOP])){
      if(th < abs((src-ln)->y - (src+ln)->y)){
        *dst = do_dirflt_left(fp, src, ln);
      }
      ++src;
      ++dst;
      for(j=2; j<fpip->w; ++j){
        if(th < abs((src-ln)->y - (src+ln)->y)){
          *dst = do_dirflt(fp, src, ln);
        }
        ++src;
        ++dst;
      }
      if(th < abs((src-ln)->y - (src+ln)->y)){
        *dst = do_dirflt_right(fp, src, ln);
      }
    }
  }
  
  return 0;

}

// 1C̍
int line_diff(FILTER *fp,FILTER_PROC_INFO *fpip)
{
  int h = fpip->h - 1;
  int i,j;
  int l = fpip->max_w;
  short diff;
  short th = fp->track[T_LDIFF] * 8;
  PIXEL_YC *src, *dst;
  PIXEL_YC yctmp;

  for(i=1; i<h; i++){
    src = fpip->ycp_edit + i*l;
    dst = fpip->ycp_temp + i*l;

    for(j=0; j<fpip->w; ++j){
      diff = (src-l)->y - (src+l)->y;
      if(abs(diff) < th){
        //yctmp = *src;
        yctmp.y = yctmp.cb = yctmp.cr = 0;
      }
      else if(diff>0){
        yctmp.y = diff;
        yctmp.cb = yctmp.cr = 1024;
      }else{
        yctmp.y = -diff;
        yctmp.cb = yctmp.cr = -1024;
      }
      *dst = yctmp;
      ++src;
      ++dst;
    }
  }

  return 0;
}


// oŕԌʂƂƂ̉摜uh
int timeflt(FILTER *fp,FILTER_PROC_INFO *fpip)
{
  int i,j;
  int l = fpip->max_w;
  int diff;
  int th = fp->track[T_TDIFF] * 8;
  int rth = 8192/(th+1);
  PIXEL_YC *src, *dst, *ref, *ref0;
  PIXEL_YC yctmp;
  D *pd;
  
  ref0 = fp->exfunc->get_ycp_filtering_cache_ex( fp, fpip->editp, fpip->frame-1, NULL, NULL);
  if(NULL == ref0)
    return 1;

  // op̈̊m
  if(NULL == gp_diff || l*fpip->h != gp_diff_size){
    if(NULL != gp_diff) free(gp_diff);
    gp_diff = malloc(l*fpip->h * sizeof(D));
    if(NULL == gp_diff){
      gp_diff_size = 0;
      return 2;
    }
    gp_diff_size = l*fpip->h;
  }

  // o
  for(i=1; i<fpip->h-1; i++){
    ref = ref0 + i*l;
    src = fpip->ycp_temp + i*l;
    pd = gp_diff + i*l;
    for(j=0; j<fpip->w; ++j){
      yctmp = avr_yc(src-l, src+l);
      pd->field = sad_yc(src, &yctmp);
      pd->frame = sad_yc(src, ref);

      ++pd;
      ++src;
      ++ref;
    }
  }
  
  for(i=1; i<fpip->h-1; i++){
    src = fpip->ycp_edit + i*l;
    dst = fpip->ycp_temp + i*l;
    pd = gp_diff + i*l;
    
    //o̕\
    if(fp->check[C_DISP]){
      for(j=0; j<fpip->w; ++j){
        diff = pd->field;
        if(fp->check[C_FRAME])
          diff = pd->frame>th ? diff : 0; 
        if(fp->check[C_FRAMEP]){
          if(j==0)
            diff = 2*pd->frame + (pd+l)->frame + (pd+l)->frame + (pd+1)->frame;
          else if(j<fpip->w-1)
            diff = pd->frame + (pd+l)->frame + (pd-l)->frame + (pd+1)->frame + (pd+1)->frame;
          else
            diff = 2*pd->frame + (pd-l)->frame + (pd+l)->frame + (pd-1)->frame;
        }
        if(diff >= th){
          yctmp.y = 4095 - src->y;
          yctmp.cb = - src->cb;
          yctmp.cr = - src->cr;
          *dst = yctmp;
        }
        ++pd;
        ++src;
        ++dst;
      }
      continue;
    }


    if(((i&1) && fp->check[C_TOP]) || ((0 == (i&1)) && 0 == fp->check[C_TOP])){
      for(j=0; j<fpip->w; ++j){
        diff = pd->field; // Ȍo
        if(fp->check[C_FRAME]) // ԍ
          diff = pd->frame>th ? diff : 0; 
        if(fp->check[C_FRAMEP]){ // ㉺{E̍l
          if(j==0)
            diff = 2*pd->frame + (pd+l)->frame + (pd+l)->frame + (pd+1)->frame;
          else if(j<fpip->w-1)
            diff = pd->frame + (pd+l)->frame + (pd-l)->frame + (pd+1)->frame + (pd+1)->frame;
          else
            diff = 2*pd->frame + (pd-l)->frame + (pd+l)->frame + (pd-1)->frame;
        }
        if(diff >= th){
          *dst = *src;
        }else if(diff >= th/2){
          // soft switching IȏĂ݂
          diff -= th/2;
          diff = (diff * 32 * rth)/4096;
          yctmp.y = (diff*src->y +  (32-diff)*dst->y)/32;
          yctmp.cb = (diff*src->cb + (32-diff)*dst->cb)/32;
          yctmp.cr = (diff*src->cr + (32-diff)*dst->cr)/32;
          *dst = yctmp;
        }

        ++pd;
        ++src;
        ++dst;
      }
    }
  }

  return 0;
}

// ͈͂𐧌
int region(FILTER *fp, FILTER_PROC_INFO *fpip)
{
  int t = fp->track[T_TOP];
  int l = fp->track[T_LEFT];
  int i,j,h,w;
  int mw = fpip->max_w;
  PIXEL_YC *src, *dst;
  PIXEL_YC yc;

  h = t + fp->track[T_HEIGHT];
  w = l + fp->track[T_WIDTH];
  h = h>fpip->h ? fpip->h : h;
  w = w>fpip->w ? fpip->w : w;
  if(fp->check[C_DISP]){
    for(i=t ; i<h; ++i){
      src = fpip->ycp_temp + i*mw + l;
      dst = fpip->ycp_edit + i*mw + l;
      for(j=l ; j<w; ++j){
        yc = *src;
        yc.y = 4095 - yc.y;
        yc.cb = - yc.cb;
        yc.cr = - yc.cr;
        *dst = yc;
        ++src;
        ++dst;
      }
    }
  }else{
    for(i=0 ; i<fpip->h; ++i){
      src = fpip->ycp_temp + i*mw;
      dst = fpip->ycp_edit + i*mw;
      for(j=0 ; j<fpip->w; ++j){
        if(i<t || i>=h || j<l || j>=w)
          *dst = *src;
        ++src;
        ++dst;
      }
    }
  }
  
  return 0;
}
     
